(****************************************************************************

                        InterStellar Annihilation (ISA)
                              Spider's Realm IGM
                       Copyright(c) 2001-2002 Andy Stewart

Version  : 0.994
Compiler : Turbo Pascal 7.0
Updated  : 11.18.02

 ****************************************************************************)
Program SpidersRealm;

{.$APPTYPE CONSOLE}
{ Define this if compiling under Delphi }

{$M 32768,0,100000}
{ REM this out if compiling under Delphi }

{.$DEFINE HUGESTR}
{ Define this if using HugeString in Project options - Delphi}

{$DEFINE ISAIGM}
{Yup, it's an ISA IGM <g>}

Uses
 Angel,         { Doorkit }
 aISA,          { Read/Write USER????.IN/OUT routines }
 Screens,       { Welcome & Goodbye Screens, Menus }
 Comments,      { Comments Stuff }
 Crt,           { Duh! }
 Dos;           { Duh! }


Procedure GetNewPassword;
{ Get the new password }
var
  NewPass : String;

begin
  DrawStars;
  aWriteICCln('^\LF^\03  You insert the money into the terminal^\0B, ^\03which quickly snags it^\0B.^\LF^\LF');

  aWriteICCln('^\0E  !!! ^\0FNOTICE ^\0E!!!^\LF');
  aWriteICCln('^\03  This terminal is currently experiencing technical difficulties^\0B,');
  aWriteICCln('^\03  therefore you get one^\0B,^\03 and only one chance to input your new password^\0B.');
  aWriteICCln('^\03  Be VERY careful^\0B!^\LF');

  aWriteICCln('^\03  Space Terminal Programming position available^\0B.');
  aWriteICCln('^\03  Call extension ^\09156 ^\03to inquire^\0B.^\LF');
  aWriteICCln('                                                     ^\0F- ^\03Lord Spider^\LF');

  aWriteICC('^\0F  ^\03Enter your new password ^\0B: ^\09');
  ginput2(NewPass,35,#176,'I am a buttweed, fear my seeds!');

  if NewPass <> '' then ISAUser.UGroundPass := NewPass;

  aWriteICCln('^\LF^\03  The UnderGround will be notified of the change^\0B.');
  newlnn(2);
  newpause;
end;



Procedure ChangeUGroundPass;
{ Allows user to change there UnderGround password if they have enough
  Money. }
var
  Cost : longint;
  SEL  : char;

begin
  DrawStars;

  aWriteICCln('^\LF^\0F ^\03As you press the terminal key^\0B, ^\03a hologram of an odd looking');
  aWriteICCln('^\03  creature appears next to you^\0B.^\LF');

  aWriteICCln('^\0B  "^\03So^\0B, ^\03you wish to change your UnderGround Password^\0B, ^\03do you^\0B?"');
  aWriteICCln('^\03  says the creature^\0B.  "^\03Doncha ^\0EHATE ^\03it when you forget a password^\0B!?"^\LF');

  aWriteICCln('^\0B  "^\03Well^\0B, ^\03changing your password is ^\EFNOT ^\03cheap^\0B!  ^\03See^\0B, ^\03Spider' +
              ' and the UnderGround');
  aWriteICCLn('^\03  each get a cut of the fee^\0B... ^\03then there^\0B''^\03s ^\0EMY ^\03fee^\0B, ^\03of course^\0B!"^\LF');

  Cost := (length(ISAUser.UGroundPass) * 1000);
  Cost := Cost * ISAUser.Plays;

  aWriteICCln('^\0B  "^\03You look like a decent type^\0B...  ^\03I^\0B''^\03ll only charge ya ^\0B$^\09' +
                     addcommas(cstr(Cost)) + '^\0B.');
  if Cost > ISAUser.Money then
    begin
      aWriteICCln('^\0B  "^\03However^\0B, ^\03you don^\0B''^\03t have that much cash on ya^\0B!');
      aWriteICCln('^\03  go find some^\0B, ^\03then come back and see me^\0B.^\LF');
      aWriteICCln('^\03  That said^\0B, ^\03the hologram disappears^\0B.  ^\03Find some money^\0B, ^\03huh^\0B?^\LF');
      newpause;
      exit;
    end;
  aWriteICC('^\LF ^\0F ^\03Accept ^\0B[^\09Y^\0B/^\09n^\0B] : ^\09');
  OneChar(SEL,'YN'+#10#13);
  case SEL of
    'N' : begin
            aWriteICCln('^\09No');
            delay(250);
            exit;
          end;
    #10,
    #13,
    'Y': begin
           aWriteICCln('^\09Yes');
           delay(250);
           ISAUser.Money := ISAUser.Money - Cost;
           GetNewPassword;
         end;
  end { case }
end;

Procedure GetNewName;
{ Get the new Empire Name }
var
  NewName : String;

begin
  DrawStars;
  aWriteICCln('^\LF^\03  You insert the money into the terminal^\0B, ^\03which quickly snags it^\0B.^\LF^\LF');

  aWriteICCln('^\0E  !!! ^\0FNOTICE ^\0E!!!^\LF');
  aWriteICCln('^\03  This terminal is currently experiencing technical difficulties^\0B,');
  aWriteICCln('^\03  therefore you get one^\0B,^\03 and only one chance to input your new name^\0B.');
  aWriteICCln('^\03  Be VERY careful^\0B!^\LF');

  aWriteICCln('^\03  Space Terminal Programming position available^\0B.');
  aWriteICCln('^\03  Call extension ^\09156 ^\03to inquire^\0B.^\LF');
  aWriteICCln('                                                     ^\0F- ^\03Lord Spider^\LF');

  aWriteICC('^\0F  ^\03Enter your new Empire Name ^\0B: ^\09');
  ginput2(NewName,35,#176,'I''m a bonehead!');

  if NewName <> '' then ISAUser.Alias := NewName;

  aWriteICCln('^\LF^\03  Your empire name has been changed^\0B.');
  newlnn(2);
  newpause;
end;


Procedure ChangeEmpireName;
{ Allows user to change their Empire Name if they have enough Money. }
var
  Cost : longint;
  SEL  : char;

begin
  DrawStars;

  aWriteICCln('^\LF^\0F ^\03As you press the terminal key^\0B, ^\03a hologram of an odd looking');
  aWriteICCln('^\03  creature appears next to you^\0B.^\LF');

  aWriteICCln('^\0B  "^\03So^\0B, ^\03you wish to change Empire Name^\0B, ^\03do you^\0B?"');
  aWriteICCln('^\03  says the creature^\0B.  "^\03Someone after your butt or something^\0B?"^\LF');

  aWriteICCln('^\0B  "^\03Well^\0B, ^\03changing your name is ^\EFNOT ^\03cheap^\0B!  ^\03See^\0B, ^\03the' +
              ' Galactic Police frown');
  aWriteICCLn('^\03  upon this sort of thing^\0B... ^\03so there is much I must to do make it slide by^\0B!"^\LF');

  Cost := ((length(ISAUser.Alias) * 2500)) * ISAUser.Plays;
{  Cost := Cost * ISAUser.Plays;}

  aWriteICCln('^\0B  "^\03You look like a decent type^\0B...  ^\03I^\0B''^\03ll only charge ya ^\0B$^\09' +
                     addcommas(cstr(Cost)) + '^\0B.');
  if Cost > ISAUser.Money then
    begin
      aWriteICCln('^\0B  "^\03However^\0B, ^\03you don^\0B''^\03t have that much cash on ya^\0B!');
      aWriteICCln('^\03  go find some^\0B, ^\03then come back and see me^\0B.^\LF');
      aWriteICCln('^\03  That said^\0B, ^\03the hologram disappears^\0B.  ^\03Find some money^\0B, ^\03huh^\0B?^\LF');
      newpause;
      exit;
    end;
  aWriteICC('^\LF ^\0F ^\03Accept ^\0B[^\09Y^\0B/^\09n^\0B] : ^\09');
  OneChar(SEL,'YN'+#10#13);
  case SEL of
    'N' : begin
            aWriteICCln('^\09No');
            delay(250);
            exit;
          end;
    #10,
    #13,
    'Y': begin
           aWriteICCln('^\09Yes');
           delay(250);
           ISAUser.Money := ISAUser.Money - Cost;
           GetNewName;
         end;
  end { case }
end;


Procedure MainMenu;
{ The Main Menu, what else? :) }

var
  SEL: char;

begin
  repeat
    MainMenuAnsi;
    OneChar(SEL,'1234Q?!'+#10#13);
    case SEL of
      '1' : begin
              aWriteICCln('^\09Change Underground Password');
              delay(250);
              ChangeUGroundPass;
            end;
      '2' : begin
              aWriteICCln('^\09Change Empire Name');
              delay(250);
              ChangeEmpireName;
            end;
      '3' : begin
              aWriteICCln('^\09Read/Write Comments');
              delay(250);
              RunComments;
            end;
      '4' : begin
              aWriteICCln('^\09Display Empires');
              delay(250);
              DisplayEmpires;
            end;
      '!' : begin
              aWriteICCln('^\09Display Variables');
              delay(250);
              DisplayUserOut;
            end;
      '?' : begin
              aWriteICCln('^\09Redraw');
              delay(250);
            end;
      #10,
      #13,
      'Q' : begin
              aWriteICCln('^\09Quit');
              delay(250);
              exit;
            end;
    end;
  until 1 = 2;
end;


Begin
  aInit;
  AI.ProgramName := 'Spider''s Realm v0.994';   { Sets IGM Name }
  AI.Author := 'Andy Stewart';                  { Sets Author Name }
  AI.StatusType := ISA;                         { Sets StatusBar Type
                                                  Set to ISA to match
                                                  ISA :) }
  AI.StatFore := 15;                            { Sets StatusBar ForeGround
                                                  Color - 15 = White }
  AI.StatBack := 4;                             { Sets StatusBar BackGround
                                                  Color - 4 = Red
                                                  I set this to red so
                                                  the sysop can quickly
                                                  determine the user is
                                                  in an IGM - ISA's StatBar
                                                  is Blue}
  AI.Ansi := True;                              { Make SURE we're Ansi! }
  ReadUserOut;                                  { Read USER????.OUT }
  ReadEmpireDat;                                { Read EMPIRES.DAT }
  WelcomeScreen;                                { Show Welcome Screen }
  MainMenu;                                     { Do Main Menu }
  WriteUserIn;                                  { Write USER????.IN }
  GoodByeScreen;                                { Show Goodbye Screen }
  AExit(255);                                   { Exit door with errorlevel
                                                  255 (Everything OK) }
End.  { SPIDER.PAS }